# Script Books.py
# Copyright (c) 2006-2006 Quadralay Corporation
#


import os
import urllib


def GetBookDirectoryPaths(ParamPath):
  # Determine book list file path
  #
  VarBookListFilePath = os.path.join(ParamPath, 'wwhelp', 'wwhimpl', 'common', 'private', 'books.js')

  # Load book list JavaScript file
  #
  VarFile = open(VarBookListFilePath, 'r')
  VarLines = VarFile.readlines()
  VarFile.close()

  # Record book directory paths
  #
  VarBookDirectoryPaths = []
  for VarLine in VarLines:
    VarAddDirectoryIndex = VarLine.find('.fAddDirectory("')
    if (VarAddDirectoryIndex >= 0):
      VarFirstQuoteIndex = VarLine.find('"', VarAddDirectoryIndex)
      VarSecondQuoteIndex = VarLine.find('"', VarFirstQuoteIndex + 1)
      VarBookDirectoryPath = VarLine[(VarFirstQuoteIndex + 1):VarSecondQuoteIndex];

      # Add book directory path
      #
      # Verify correct book directory path encoding
      #
      VarAbsoluteBookDirectoryPath = os.path.normpath(os.path.join(ParamPath, VarBookDirectoryPath))
      if (os.path.exists(VarAbsoluteBookDirectoryPath)):
        VarBookDirectoryPaths.append(VarBookDirectoryPath)
      else:
        VarBookDirectoryPaths.append(urllib.unquote(VarBookDirectoryPath))

  return VarBookDirectoryPaths
