# Script Import.py
# Copyright (c) 2006-2006 Quadralay Corporation
#

def FilterPassThrough(ParamLines):
  return ParamLines


def FilterCommonBookListScript(ParamLines):
  VarFilteredLines = []

  VarInFunction = ''
  VarStripLoop = False
  for VarLine in ParamLines:
    if (VarStripLoop):
      if (VarLine.startswith('  }')):
        VarStripLoop = False
      else:
        pass
    elif (VarInFunction == 'WWHBookList_Init_BookData_Script'):
      if (VarLine.startswith('}')):
        VarInFunction = ''
        VarFilteredLines.append(VarLine)
      elif (VarLine.startswith('  for (MaxIndex = this.mBookList.length, Index = 0 ; Index < MaxIndex ; Index++)')):
        VarFilteredLines.append('  Scripts.fAppend("<script type=\\"text/javascript\\" language=\\"JavaScript1.2\\" src=\\"" + WWHFrame.WWHHelp.mHelpURLPrefix + "wwhbdata/common.js" + VarParameters + "\\"></script>\\n");\n')
        VarStripLoop = True
      elif (VarLine.startswith('  var  MaxIndex = 0;')):
        pass
      elif (VarLine.startswith('  var  Index    = 0;')):
        pass
      else:
        VarFilteredLines.append(VarLine)
    elif (VarLine.startswith('function  WWHBookList_Init_BookData_Script()')):
      VarInFunction = 'WWHBookList_Init_BookData_Script'
      VarFilteredLines.append(VarLine)
    else:
      VarFilteredLines.append(VarLine)

  return VarFilteredLines


def FilterCommonHelpScript(ParamLines):
  VarFilteredLines = []

  VarInFunction = ''
  VarFirstImageSrc = True
  for VarLine in ParamLines:
    if (VarInFunction == 'WWHHelpUtilities_PreloadGraphics'):
      if (VarLine.startswith('}')):
        VarInFunction = ''
        VarFilteredLines.append(VarLine)
      elif (VarLine.startswith('  var  VarImage = new Image();')):
        pass
      elif (VarLine.startswith('  VarImage.src = VarImageDirectory + "')):
        if (VarFirstImageSrc):
          VarFilteredLines.append('  this.mImages = new Array();\n')
          VarFirstImageSrc = False
        VarFilteredLines.append(VarLine.replace('  VarImage.src = VarImageDirectory + "', '  this.mImages[this.mImages.length] = new Image(); this.mImages[this.mImages.length - 1].src = VarImageDirectory + "'))
      else:
        VarFilteredLines.append(VarLine)
    elif (VarLine.startswith('function  WWHHelpUtilities_PreloadGraphics()')):
      VarInFunction = 'WWHHelpUtilities_PreloadGraphics'
      VarFilteredLines.append(VarLine)
    else:
      VarFilteredLines.append(VarLine)

  return VarFilteredLines


def FilterJavaScriptHandlerScript(ParamLines):
  VarFilteredLines = []

  VarInFunction = ''
  VarFirstImageSrc = True
  for VarLine in ParamLines:
    if (VarInFunction == 'WWHHandler_Finalize'):
      if (VarLine.startswith('}')):
        VarInFunction = ''
        VarFilteredLines.append(VarLine)
      elif (VarLine.startswith('  var  VarImage = new Image();')):
        pass
      elif (VarLine.startswith('  VarImage.src = VarImageDirectory + "')):
        if (VarFirstImageSrc):
          VarFilteredLines.append('  this.mImages = new Array();\n')
          VarFirstImageSrc = False
        VarFilteredLines.append(VarLine.replace('  VarImage.src = VarImageDirectory + "', '  this.mImages[this.mImages.length] = new Image(); this.mImages[this.mImages.length - 1].src = VarImageDirectory + "'))
      else:
        VarFilteredLines.append(VarLine)
    elif (VarLine.startswith('function  WWHHandler_Finalize()')):
      VarInFunction = 'WWHHandler_Finalize'
      VarFilteredLines.append(VarLine)
    else:
      VarFilteredLines.append(VarLine)

  return VarFilteredLines


def FilterJavaScriptIndexScript(ParamLines):
  VarFilteredLines = []

  VarInFunction = ''
  VarStripLoop = False
  for VarLine in ParamLines:
    if (VarStripLoop):
      if (VarLine.startswith('  }')):
        VarStripLoop = False
      else:
        pass
    elif (VarInFunction == 'WWHIndex_InitBodyHTML'):
      if (VarLine.startswith('}')):
        VarInFunction = ''
        VarFilteredLines.append(VarLine)
      elif (VarLine.startswith('  for (MaxIndex = VarBookList.length, Index = 0 ; Index < MaxIndex ; Index++)')):
        VarFilteredLines.append('  VarHTML.fAppend("<script language=\\"JavaScript1.2\\" src=\\"" + WWHFrame.WWHHelp.mHelpURLPrefix + "wwhbdata/js/index.js" + VarParameters + "\\"></script>\\n");\n')
        VarStripLoop = True
      elif (VarLine.startswith('  var  MaxIndex;')):
        pass
      elif (VarLine.startswith('  var  Index;')):
        pass
      else:
        VarFilteredLines.append(VarLine)
    elif (VarLine.startswith('function  WWHIndex_InitBodyHTML()')):
      VarInFunction = 'WWHIndex_InitBodyHTML'
      VarFilteredLines.append(VarLine)
    else:
      VarFilteredLines.append(VarLine)

  return VarFilteredLines


def FilterJavaScriptOutlineScript(ParamLines):
  VarFilteredLines = []

  VarInFunction = ''
  VarStripLoop = False
  for VarLine in ParamLines:
    if (VarStripLoop):
      if (VarLine.startswith('  }')):
        VarStripLoop = False
      else:
        pass
    elif (VarInFunction == 'WWHOutline_InitBodyHTML'):
      if (VarLine.startswith('}')):
        VarInFunction = ''
        VarFilteredLines.append(VarLine)
      elif (VarLine.startswith('  for (MaxIndex = BookList.length, Index = 0 ; Index < MaxIndex ; Index++)')):
        VarFilteredLines.append('  HTML.fAppend("<script language=\\"JavaScript1.2\\" src=\\"" + WWHFrame.WWHHelp.mHelpURLPrefix + "wwhbdata/js/toc.js" + VarParameters + "\\"></script>\\n");\n')
        VarStripLoop = True
      elif (VarLine.startswith('  var  MaxIndex;')):
        pass
      elif (VarLine.startswith('  var  Index;')):
        pass
      else:
        VarFilteredLines.append(VarLine)
    elif (VarLine.startswith('function  WWHOutline_InitBodyHTML()')):
      VarInFunction = 'WWHOutline_InitBodyHTML'
      VarFilteredLines.append(VarLine)
    else:
      VarFilteredLines.append(VarLine)

  return VarFilteredLines


def FilterJavaScriptPanelsScript(ParamLines):
  VarFilteredLines = []

  VarInFunction = ''
  for VarLine in ParamLines:
    if (VarInFunction == 'WWHPanels_ReloadPanel'):
      if (VarLine.startswith('}')):
        VarInFunction = ''
        VarFilteredLines.append(VarLine)
      elif (VarLine.startswith('      HTMLFilename = "panelmsg.htm";')):
        VarFilteredLines.append(VarLine.replace('"panelmsg.htm"', '"panelini.htm"'))
      else:
        VarFilteredLines.append(VarLine)
    elif (VarLine.startswith('function  WWHPanels_ReloadPanel()')):
      VarInFunction = 'WWHPanels_ReloadPanel'
      VarFilteredLines.append(VarLine)
    else:
      VarFilteredLines.append(VarLine)

  return VarFilteredLines


def FilterJavaScriptSearchScript(ParamLines):
  VarFilteredLines = []

  VarInFunction = ''
  VarStripLoop = False
  for VarLine in ParamLines:
    if (VarStripLoop):
      if (VarLine.startswith('  }')):
        VarStripLoop = False
      else:
        pass
    elif (VarInFunction == 'WWHSearch_InitBodyHTML'):
      if (VarLine.startswith('}')):
        VarInFunction = ''
        VarFilteredLines.append(VarLine)
      elif (VarLine.startswith('  var  BookList;')):
        pass
      elif (VarLine.startswith('  var  MaxIndex;')):
        pass
      elif (VarLine.startswith('  var  Index;')):
        pass
      elif (VarLine.startswith('  BookList = WWHFrame.WWHHelp.mBooks.mBookList;')):
        pass
      elif (VarLine.startswith('  for (MaxIndex = BookList.length, Index = 0 ; Index < MaxIndex ; Index++)')):
        VarFilteredLines.append('  HTML.fAppend("<script language=\\"JavaScript1.2\\" src=\\"" + WWHFrame.WWHHelp.mHelpURLPrefix + "wwhbdata/js/search.js" + VarParameters + "\\"></script>\\n");\n')
        VarStripLoop = True
      else:
        VarFilteredLines.append(VarLine)
    elif (VarLine.startswith('function  WWHSearch_InitBodyHTML()')):
      VarInFunction = 'WWHSearch_InitBodyHTML'
      VarFilteredLines.append(VarLine)
    else:
      VarFilteredLines.append(VarLine)

  return VarFilteredLines


def FilterCommonHTMLFile(ParamLines):
  VarFilteredLines = []

  VarFirstCommonPrivate = True
  VarFirstCommonScript = True

  for VarLine in ParamLines:
    if (VarLine.startswith('  <script type="text/javascript" language="JavaScript1.2" src="../private/title.js"></script>')):
      VarFilteredLines.append(VarLine)
    elif (VarLine.startswith('  <script type="text/javascript" language="JavaScript1.2" src="../private/')):
      if (VarFirstCommonPrivate):
        VarFilteredLines.append('  <script type="text/javascript" language="JavaScript1.2" src="../private.js"></script>\n')
        VarFirstCommonPrivate = False
      else:
        pass
    elif (VarLine.startswith('  <script type="text/javascript" language="JavaScript1.2" src="../scripts/')):
      if (VarFirstCommonScript):
        VarFilteredLines.append('  <script type="text/javascript" language="JavaScript1.2" src="../scripts.js"></script>\n')
        VarFirstCommonScript = False
      else:
        pass
    else:
      VarFilteredLines.append(VarLine)

  return VarFilteredLines


def FilterJavaScriptHTMLFile(ParamLines):
  VarFilteredLines = []

  VarFirstCommonPrivate = True
  VarFirstCommonScript = True
  VarFirstJavaScriptPrivate = True
  VarFirstJavaScriptScript = True

  for VarLine in ParamLines:
    if (VarLine.startswith('  <script type="text/javascript" language="JavaScript1.2" src="../private/')):
      if (VarFirstCommonPrivate):
        VarFilteredLines.append('  <script type="text/javascript" language="JavaScript1.2" src="../private.js"></script>\n')
        VarFirstCommonPrivate = False
      else:
        pass
    elif (VarLine.startswith('  <script type="text/javascript" language="JavaScript1.2" src="../scripts/')):
      if (VarFirstCommonScript):
        VarFilteredLines.append('  <script type="text/javascript" language="JavaScript1.2" src="../scripts.js"></script>\n')
        VarFirstCommonScript = False
      else:
        pass
    elif (VarLine.startswith('  <script type="text/javascript" language="JavaScript1.2" src="../../common/private/title.js"></script>')):
      VarFilteredLines.append(VarLine)
    elif (VarLine.startswith('  <script type="text/javascript" language="JavaScript1.2" src="../../common/private/')):
      if (VarFirstJavaScriptPrivate):
        VarFilteredLines.append('  <script type="text/javascript" language="JavaScript1.2" src="../../common/private.js"></script>\n')
        VarFirstJavaScriptPrivate = False
      else:
        pass
    elif (VarLine.startswith('  <script type="text/javascript" language="JavaScript1.2" src="../../common/scripts/')):
      if (VarFirstJavaScriptScript):
        VarFilteredLines.append('  <script type="text/javascript" language="JavaScript1.2" src="../../common/scripts.js"></script>\n')
        VarFirstJavaScriptScript = False
      else:
        pass
    else:
      VarFilteredLines.append(VarLine)

  return VarFilteredLines


class FilterBookData:
  def __init__(self,
               ParamBookIndex):
    self.mBookIndex = ParamBookIndex


  def __call__(self,
               ParamLines):
    VarFilteredLines = []

    for VarLine in ParamLines:
      if (VarLine.find('WWHBookData_Title') > 0):
        VarFilteredLines.append(VarLine.replace('WWHBookData_Title', 'WWHBookData_Title_%d' % (self.mBookIndex)))
      elif (VarLine.find('WWHBookData_Context') > 0):
        VarFilteredLines.append(VarLine.replace('WWHBookData_Context', 'WWHBookData_Context_%d' % (self.mBookIndex)))
      elif (VarLine.find('WWHBookData_Files') > 0):
        VarFilteredLines.append(VarLine.replace('WWHBookData_Files', 'WWHBookData_Files_%d' % (self.mBookIndex)))
      elif (VarLine.find('WWHBookData_ALinks') > 0):
        VarFilteredLines.append(VarLine.replace('WWHBookData_ALinks', 'WWHBookData_ALinks_%d' % (self.mBookIndex)))
      else:
        VarFilteredLines.append(VarLine)

    return VarFilteredLines


class FilterTOCBookData:
  def __init__(self,
               ParamBookIndex):
    self.mBookIndex = ParamBookIndex


  def __call__(self,
               ParamLines):
    VarFilteredLines = []

    for VarLine in ParamLines:
      if (VarLine.find('WWHBookData_AddTOCEntries') > 0):
        VarFilteredLines.append(VarLine.replace('WWHBookData_AddTOCEntries', 'WWHBookData_AddTOCEntries_%d' % (self.mBookIndex)))
      else:
        VarFilteredLines.append(VarLine)

    return VarFilteredLines


class FilterIndexBookData:
  def __init__(self,
               ParamBookIndex):
    self.mBookIndex = ParamBookIndex


  def __call__(self,
               ParamLines):
    VarFilteredLines = []

    for VarLine in ParamLines:
      if (VarLine.find('WWHBookData_MaxIndexLevel') > 0):
        VarFilteredLines.append(VarLine.replace('WWHBookData_MaxIndexLevel', 'WWHBookData_MaxIndexLevel_%d' % (self.mBookIndex)))
      elif (VarLine.find('WWHBookData_AddIndexEntries') > 0):
        VarFilteredLines.append(VarLine.replace('WWHBookData_AddIndexEntries', 'WWHBookData_AddIndexEntries_%d' % (self.mBookIndex)))
      else:
        VarFilteredLines.append(VarLine)

    return VarFilteredLines


class FilterSearchBookData:
  def __init__(self,
               ParamBookIndex):
    self.mBookIndex = ParamBookIndex


  def __call__(self,
               ParamLines):
    VarFilteredLines = []

    VarInFunction = ''
    for VarLine in ParamLines:
      if (VarInFunction == 'WWHBookData_SearchFileCount'):
        if (VarLine.startswith('}')):
          VarInFunction = ''
          VarFilteredLines.append(VarLine)
        elif (VarLine.startswith('  return ')):
          VarFilteredLines.append('  return 1;\n')
        else:
          VarFilteredLines.append(VarLine)
      elif (VarLine.startswith('function  WWHBookData_SearchFileCount()')):
        VarInFunction = 'WWHBookData_SearchFileCount'
        VarFilteredLines.append(VarLine.replace('WWHBookData_SearchFileCount', 'WWHBookData_SearchFileCount_%d' % (self.mBookIndex)))
      elif (VarLine.find('WWHBookData_SearchFileCount') > 0):
        VarFilteredLines.append(VarLine.replace('WWHBookData_SearchFileCount', 'WWHBookData_SearchFileCount_%d' % (self.mBookIndex)))
      elif (VarLine.find('WWHBookData_SearchMinimumWordLength') > 0):
        VarFilteredLines.append(VarLine.replace('WWHBookData_SearchMinimumWordLength', 'WWHBookData_SearchMinimumWordLength_%d' % (self.mBookIndex)))
      elif (VarLine.find('WWHBookData_SearchSkipWords') > 0):
        VarFilteredLines.append(VarLine.replace('WWHBookData_SearchSkipWords', 'WWHBookData_SearchSkipWords_%d' % (self.mBookIndex)))
      else:
        VarFilteredLines.append(VarLine)

    return VarFilteredLines


def FilterSearchFiles(ParamLines):
  VarFilteredLines = []

  for VarLine in ParamLines:
    if (VarLine.startswith('function BookData_Search(x,y)')):
      pass
    elif (VarLine.startswith('{')):
      pass
    elif (VarLine.startswith('}')):
      pass
    else:
      VarFilteredLines.append(VarLine)

  return VarFilteredLines
